<script setup lang="ts">
import { computed } from "vue";
import BaseButton from "@/components/BaseButton.vue";

const props = defineProps<{
  id: string;
  title: string;
  accept: string;
  name: string;
  modelValue: File | undefined;
  errorMsg?: string;
  removeMsg?: string;
  validator?: (input: File | undefined) => boolean;
}>();

const emit = defineEmits<{
  (e: "update:modelValue", value: File | null): void;
}>();

const errorId = computed(() => `${props.id}_error`);
const isError = computed(() =>
  Boolean(
    props.modelValue &&
      props.errorMsg &&
      props.validator &&
      !props.validator(props.modelValue)
  )
);

function handleInput(e: Event) {
  if (!(e.target instanceof HTMLInputElement)) {
    return;
  }

  const file = e.target.files?.[0];

  if (!file) {
    return;
  }

  emit("update:modelValue", file);
}
</script>

<template>
  <div class="wrapper">
    <label v-if="!modelValue || isError" :for="id" class="field">
      <span class="title">Choose a file</span>
      <input
        :id="id"
        type="file"
        :accept="accept"
        :name="name"
        autocomplete="off"
        class="input"
        :aria-describedby="errorId"
        @input="handleInput"
      />
      <span v-if="isError" :id="errorId" class="error" aria-live="assertive">
        {{ errorMsg }}
      </span>
    </label>
    <BaseButton
      v-else-if="removeMsg"
      class="btn-remove"
      type="button"
      @click="() => emit('update:modelValue', null)"
    >
      {{ removeMsg }}
    </BaseButton>
  </div>
</template>

<style lang="scss" scoped>
.wrapper {
  --button-border-radius: 0.8rem;
  --button-width: 14rem;
  --button-height: 4.2rem;
}

.field {
  display: grid;
  grid-template: var(--button-height) / var(--button-width);
  justify-items: center;
  row-gap: 1rem;
  transition: transform var(--transition-config);
}

.input {
  width: 100%;
  height: 100%;
  grid-row: 1;
  grid-column: 1;
  opacity: 0;
  overflow: hidden;
}

.title {
  width: 100%;
  height: 100%;
  grid-row: 1;
  grid-column: 1;
  display: grid;
  place-content: center;
  line-height: 0;
  cursor: pointer;
  z-index: 1; /* this will make cursor: pointer for the whole area */
  background-color: var(--color-primary);
  box-shadow: var(--box-shadow-size) var(--color-primary-shadow-light);
  color: var(--color-light);
  border-radius: var(--button-border-radius);

  .field:focus-within & {
    outline: 0.25rem solid var(--color-dark);
  }

  .field:hover & {
    transform: scale(1.05);
  }
}

.error {
  color: var(--color-alert);
  width: max-content;
}

.btn-remove {
  width: var(--button-width);
  height: var(--button-height);
  border-radius: var(--button-border-radius);

  &:focus {
    outline: 0.2rem solid var(--color-dark);
  }
}
</style>
